diff -urN punbb-1.4.2/lang/English/login.php punbb-1.4.3/lang/English/login.php
--- punbb-1.4.2/lang/English/login.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/lang/English/login.php	2015-06-15 09:21:05.000000000 -0400
@@ -21,6 +21,7 @@
 'Obtain pass'						=>	'new password',
 'register'							=>	'register',
 'Submit password request'			=>	'Submit request',
+'Email important'					=>	'Contact the forum administrator at %s to change password on specified email address.',
 'Email flood'						=>	'This account has already requested a new password in the past %s seconds. Please wait a while before requesting a new password again.',
 'New password request'				=>	'New password request',
 'New password errors'				=>	'<strong>Warning!</strong> The following errors must be corrected before a new password can be sent:',
diff -urN punbb-1.4.2/lang/English/misc.php punbb-1.4.3/lang/English/misc.php
--- punbb-1.4.2/lang/English/misc.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/lang/English/misc.php	2015-06-15 09:21:05.000000000 -0400
@@ -11,6 +11,7 @@
 'Form e-mail errors'		=>	'<strong>Warning!</strong> The following errors must be corrected before your message can be sent:',
 'No e-mail subject'			=>	'You must enter a subject.',
 'No e-mail message'			=>	'You must enter a message.',
+'Too long e-mail subject'   =>  'Subjects cannot be longer than %s characters.',
 'Too long e-mail message'	=>	'Your message length is %s bytes. This exceeds the %s bytes limit.',
 'Email flood'				=>	'At least %s seconds have to pass between sent emails. Please wait a while and try sending again.',
 'E-mail sent redirect'		=>	'Email sent.',
diff -urN punbb-1.4.2/lang/English/post.php punbb-1.4.3/lang/English/post.php
--- punbb-1.4.2/lang/English/post.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/lang/English/post.php	2015-06-15 09:21:05.000000000 -0400
@@ -5,7 +5,7 @@
 
 // Post validation stuff (many are similar to those in edit.php)
 'No subject'			=>	'Topics must contain a subject.',
-'Too long subject'		=>	'Subjects cannot be longer than 70 characters.',
+'Too long subject'		=>	'Subjects cannot be longer than %s characters.',
 'All caps subject'		=>	'Subjects cannot contain only capital letters.',
 'No message'			=>	'You must enter a message.',
 'Too long message'		=>	'Your post length is %s bytes. This exceeds the %s bytes limit.',
diff -urN punbb-1.4.2/lang/English/profile.php punbb-1.4.3/lang/English/profile.php
--- punbb-1.4.2/lang/English/profile.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/lang/English/profile.php	2015-06-15 09:21:05.000000000 -0400
@@ -92,6 +92,9 @@
 'AOL IM'					=>	'AOL IM',
 'Forbidden title'			=>	'The title you entered contains a forbidden word. You must choose a different title.',
 'Bad ICQ'					=>	'You entered an invalid ICQ UIN.',
+'Bad Twitter'				=>	'You entered an invalid Twitter account.',
+'Bad Facebook'				=>	'You entered an invalid Facebook account.',
+'Bad LinkedIn'				=>	'You entered an invalid LinkedIn account.',
 'Yahoo'						=>	'Yahoo! Messenger',
 'Posts and topics'			=>	'Posts and topics',
 'Private info'				=>	'Private information',
diff -urN punbb-1.4.2/login.php punbb-1.4.3/login.php
--- punbb-1.4.2/login.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/login.php	2015-06-15 09:21:05.000000000 -0400
@@ -205,7 +205,7 @@
 
 			// Fetch user matching $email
 			$query = array(
-				'SELECT'	=> 'u.id, u.username, u.salt, u.last_email_sent',
+				'SELECT'	=> 'u.id, u.group_id, u.username, u.salt, u.last_email_sent',
 				'FROM'		=> 'users AS u',
 				'WHERE'		=> 'u.email=\''.$forum_db->escape($email).'\''
 			);
@@ -243,6 +243,9 @@
 
 					($hook = get_hook('li_forgot_pass_pre_flood_check')) ? eval($hook) : null;
 
+					if ($cur_hit['group_id'] == FORUM_ADMIN)
+						message(sprintf($lang_login['Email important'], '<a href="mailto:'.forum_htmlencode($forum_config['o_admin_email']).'">'.forum_htmlencode($forum_config['o_admin_email']).'</a>'));
+
 					if ($cur_hit['last_email_sent'] != '' && (time() - $cur_hit['last_email_sent']) < $forgot_pass_timeout && (time() - $cur_hit['last_email_sent']) >= 0)
 						message(sprintf($lang_login['Email flood'], $forgot_pass_timeout));
 
diff -urN punbb-1.4.2/misc.php punbb-1.4.3/misc.php
--- punbb-1.4.2/misc.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/misc.php	2015-06-15 09:21:05.000000000 -0400
@@ -152,6 +152,37 @@
 	redirect(forum_link($forum_url['forum'], array($fid, sef_friendly($forum_name))), $lang_misc['Mark forum read redirect']);
 }
 
+// OpenSearch plugin?
+else if ($action == 'opensearch')
+{
+	// Send XML/no cache headers
+	header('Content-Type: text/xml; charset=utf-8');
+	header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
+	header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
+	header('Pragma: public');
+
+	echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
+	echo '<OpenSearchDescription xmlns="http://a9.com/-/spec/opensearch/1.1/" xmlns:moz="http://www.mozilla.org/2006/browser/search/">'."\n";
+	echo "\t".'<ShortName>'.forum_htmlencode($forum_config['o_board_title']).'</ShortName>'."\n";
+	echo "\t".'<Description>'.forum_htmlencode($forum_config['o_board_desc']).'</Description>'."\n";
+	echo "\t".'<InputEncoding>utf-8</InputEncoding>'."\n";
+	echo "\t".'<OutputEncoding>utf-8</OutputEncoding>'."\n";
+	echo "\t".'<Image width="16" height="16" type="image/x-icon">'.$base_url.'/favicon.ico</Image>'."\n";
+	echo "\t".'<Url type="text/html" method="get" template="'.$base_url.'/search.php?action=search&amp;source=opensearch&amp;keywords={searchTerms}"/>'."\n";
+	echo "\t".'<Url type="application/opensearchdescription+xml" rel="self" template="'.forum_link($forum_url['opensearch']).'"/>'."\n";
+	echo "\t".'<Contact>'.forum_htmlencode($forum_config['o_admin_email']).'</Contact>'."\n";
+
+	if ($forum_config['o_show_version'] == '1')
+		echo "\t".'<Attribution>PunBB '.$forum_config['o_cur_version'].'</Attribution>'."\n";
+	else
+		echo "\t".'<Attribution>PunBB</Attribution>'."\n";
+
+	echo "\t".'<moz:SearchForm>'.forum_link($forum_url['search']).'</moz:SearchForm>'."\n";
+	echo '</OpenSearchDescription>'."\n";
+
+	exit;
+}
+
 
 // Send form e-mail?
 else if (isset($_GET['email']))
@@ -202,10 +233,15 @@
 
 		if ($subject == '')
 			$errors[] = $lang_misc['No e-mail subject'];
+		else if (utf8_strlen($subject) > FORUM_SUBJECT_MAXIMUM_LENGTH)
+	     	$errors[] = sprintf($lang_misc['Too long e-mail subject'], FORUM_SUBJECT_MAXIMUM_LENGTH);
+
 		if ($message == '')
 			$errors[] = $lang_misc['No e-mail message'];
 		else if (strlen($message) > FORUM_MAX_POSTSIZE_BYTES)
-			$errors[] = sprintf($lang_misc['Too long e-mail message'], forum_number_format(strlen($message)), forum_number_format(FORUM_MAX_POSTSIZE_BYTES));
+			$errors[] = sprintf($lang_misc['Too long e-mail message'],
+				forum_number_format(strlen($message)), forum_number_format(FORUM_MAX_POSTSIZE_BYTES));
+
 		if ($forum_user['last_email_sent'] != '' && (time() - $forum_user['last_email_sent']) < $forum_user['g_email_flood'] && (time() - $forum_user['last_email_sent']) >= 0)
 			$errors[] = sprintf($lang_misc['Email flood'], $forum_user['g_email_flood']);
 
@@ -327,7 +363,7 @@
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text required longtext">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_misc['E-mail subject'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="req_subject" value="<?php echo(isset($_POST['req_subject']) ? forum_htmlencode($_POST['req_subject']) : '') ?>" size="75" maxlength="70" required /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="req_subject" value="<?php echo(isset($_POST['req_subject']) ? forum_htmlencode($_POST['req_subject']) : '') ?>" size="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" maxlength="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" required /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('mi_email_pre_message_contents')) ? eval($hook) : null; ?>
diff -urN punbb-1.4.2/moderate.php punbb-1.4.3/moderate.php
--- punbb-1.4.2/moderate.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/moderate.php	2015-06-15 09:21:05.000000000 -0400
@@ -291,8 +291,8 @@
 
 			if ($new_subject == '')
 				message($lang_post['No subject']);
-			else if (utf8_strlen($new_subject) > 70)
-				message($lang_post['Too long subject']);
+			else if (utf8_strlen($new_subject) > FORUM_SUBJECT_MAXIMUM_LENGTH)
+				message(sprintf($lang_post['Too long subject'], FORUM_SUBJECT_MAXIMUM_LENGTH));
 
 			// Get data from the new first post
 			$query = array(
@@ -381,7 +381,7 @@
 <?php ($hook = get_hook('mr_confirm_split_posts_pre_subject')) ? eval($hook) : null; ?>
 					<div class="sf-box text required">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_misc['New subject'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="new_subject" size="70" maxlength="70" required /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="new_subject" size="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" maxlength="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" required /></span>
 					</div>
 <?php ($hook = get_hook('mr_confirm_split_posts_pre_confirm_checkbox')) ? eval($hook) : null; ?>
 					<div class="sf-box checkbox">
@@ -887,6 +887,8 @@
 	$forum_page['cur_category'] = 0;
 	foreach ($forum_list as $cur_forum)
 	{
+		($hook = get_hook('mr_move_topics_forum_loop_start')) ? eval($hook) : null;
+		
 		if ($cur_forum['cid'] != $forum_page['cur_category'])	// A new category since last iteration?
 		{
 			if ($forum_page['cur_category'])
@@ -898,6 +900,8 @@
 
 		if ($cur_forum['fid'] != $fid)
 			echo "\t\t\t\t".'<option value="'.$cur_forum['fid'].'">'.forum_htmlencode($cur_forum['forum_name']).'</option>'."\n";
+			
+		($hook = get_hook('mr_move_topics_forum_loop_end')) ? eval($hook) : null;
 	}
 
 ?>
diff -urN punbb-1.4.2/post.php punbb-1.4.3/post.php
--- punbb-1.4.2/post.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/post.php	2015-06-15 09:21:05.000000000 -0400
@@ -121,8 +121,8 @@
 
 		if ($subject == '')
 			$errors[] = $lang_post['No subject'];
-		else if (utf8_strlen($subject) > 70)
-			$errors[] = $lang_post['Too long subject'];
+		else if (utf8_strlen($subject) > FORUM_SUBJECT_MAXIMUM_LENGTH)
+			$errors[] = sprintf($lang_post['Too long subject'], FORUM_SUBJECT_MAXIMUM_LENGTH);
 		else if ($forum_config['p_subject_all_caps'] == '0' && check_is_all_caps($subject) && !$forum_page['is_admmod'])
 			$errors[] = $lang_post['All caps subject'];
 	}
@@ -469,7 +469,7 @@
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text required longtext">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_post['Topic subject'] ?></span></label><br />
-						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="req_subject" value="<?php if (isset($_POST['req_subject'])) echo forum_htmlencode($subject); ?>" size="70" maxlength="70" required /></span>
+						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="req_subject" value="<?php if (isset($_POST['req_subject'])) echo forum_htmlencode($subject); ?>" size="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" maxlength="<?php echo FORUM_SUBJECT_MAXIMUM_LENGTH ?>" required /></span>
 					</div>
 				</div>
 <?php
diff -urN punbb-1.4.2/profile.php punbb-1.4.3/profile.php
--- punbb-1.4.2/profile.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/profile.php	2015-06-15 09:21:05.000000000 -0400
@@ -975,6 +975,20 @@
 			if ($form['url'] != '' && strpos(strtolower($form['url']), 'http://') !== 0 && strpos(strtolower($form['url']), 'https://') !== 0)
 				$form['url'] = 'http://'.$form['url'];
 
+			//check Facebook for validity
+			if (strpos($form['facebook'], 'http://') === 0 || strpos($form['facebook'], 'https://') === 0)
+				if (!preg_match('#https?://(www\.)?facebook.com/.+?#', $form['facebook']))
+					$errors[] = $lang_profile['Bad Facebook'];
+
+			//check Twitter for validity
+			if (strpos($form['twitter'], 'http://') === 0 || strpos($form['twitter'], 'https://') === 0)
+				if (!preg_match('#https?://twitter.com/.+?#', $form['twitter']))
+					$errors[] = $lang_profile['Bad Twitter'];
+
+			//check LinkedIn for validity
+			if (!preg_match('#https?://(www\.)?linkedin.com/.+?#', $form['linkedin']))
+					$errors[] = $lang_profile['Bad LinkedIn'];
+
 			// Add http:// if the LinkedIn doesn't contain it or https:// already
 			if ($form['linkedin'] != '' && strpos(strtolower($form['linkedin']), 'http://') !== 0 && strpos(strtolower($form['linkedin']), 'https://') !== 0)
 				$form['linkedin'] = 'http://'.$form['linkedin'];
@@ -2895,19 +2909,22 @@
 				if ($cur_forum['cid'] != $cur_category)	// A new category since last iteration?
 				{
 					if ($cur_category)
-						echo "\n\t\t\t\t\t".'</fieldset>'."\n";
+						 echo "\n\t\t\t\t\t\t".'</fieldset>'."\n";
 
-					echo "\t\t\t\t\t".'<fieldset>'."\n\t\t\t\t\t\t".'<legend><span>'.$cur_forum['cat_name'].':</span></legend>'."\n";
+					echo "\t\t\t\t\t\t".'<fieldset>'."\n\t\t\t\t\t\t\t".'<legend><span>'.$cur_forum['cat_name'].':</span></legend>'."\n";
 					$cur_category = $cur_forum['cid'];
 				}
 
 				$moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();
 
-				echo "\t\t\t\t\t\t".'<div class="checklist-item"><span class="fld-input"><input type="checkbox" id="fld'.(++$forum_page['fld_count']).'" name="moderator_in['.$cur_forum['fid'].']" value="1"'.((in_array($id, $moderators)) ? ' checked="checked"' : '').' /></span> <label for="fld'.$forum_page['fld_count'].'">'.forum_htmlencode($cur_forum['forum_name']).'</label></div>'."\n";
+				echo "\t\t\t\t\t\t\t".'<div class="checklist-item"><span class="fld-input"><input type="checkbox" id="fld'.(++$forum_page['fld_count']).'" name="moderator_in['.$cur_forum['fid'].']" value="1"'.((in_array($id, $moderators)) ? ' checked="checked"' : '').' /></span> <label for="fld'.$forum_page['fld_count'].'">'.forum_htmlencode($cur_forum['forum_name']).'</label></div>'."\n";
+				
+				($hook = get_hook('pf_change_details_admin_forum_loop_end')) ? eval($hook) : null;
 			}
 
+			if ($cur_category)
+				echo "\t\t\t\t\t\t".'</fieldset>'."\n";
 ?>
-						</fieldset>
 					</div>
 				</div>
 <?php ($hook = get_hook('pf_change_details_admin_pre_mod_assignment_fieldset_end')) ? eval($hook) : null; ?>
diff -urN punbb-1.4.2/register.php punbb-1.4.3/register.php
--- punbb-1.4.2/register.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/register.php	2015-06-15 09:21:05.000000000 -0400
@@ -53,7 +53,7 @@
 
 	($hook = get_hook('rg_rules_pre_header_load')) ? eval($hook) : null;
 
-	define('FORUM_PAGE', 'rules');
+	define('FORUM_PAGE', 'rules-register');
 	require FORUM_ROOT.'header.php';
 
 	// START SUBST - <!-- forum_main -->
diff -urN punbb-1.4.2/style/Oxygen/Oxygen.php punbb-1.4.3/style/Oxygen/Oxygen.php
--- punbb-1.4.2/style/Oxygen/Oxygen.php	2012-02-09 15:42:20.000000000 -0500
+++ punbb-1.4.3/style/Oxygen/Oxygen.php	2015-06-15 09:21:05.000000000 -0400
@@ -1,5 +1,10 @@
 <?php
 
+$forum_loader->add_js($base_url. '/style/Oxygen/responsive-nav.min.js', array('weight' => 55, 'async' => false, 'group' => FORUM_JS_GROUP_SYSTEM));
 $forum_loader->add_css($base_url.'/style/Oxygen/Oxygen.min.css', array('type' => 'url', 'group' => FORUM_CSS_GROUP_SYSTEM, 'media' => 'screen'));
 
+$tpl_main = str_replace('<!-- forum_board_title -->', forum_htmlencode($forum_config['o_board_title']), $tpl_main);
+$tpl_main = str_replace('<!-- forum_lang_menu_admin -->', $lang_common['Menu admin'], $tpl_main);
+$tpl_main = str_replace('<!-- forum_lang_menu_profile -->', $lang_common['Menu profile'], $tpl_main);
+
 ?>
